using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {

       public static void Main()
       {
CategoryBuilder.Create("Green Jewel", "The green jewel company.", ModAPI.LoadSprite("categorysprite.png"));
//Green Jewel

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "PMC Recruit", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "A recruit for the Green Jewel Company.", //new item description
        CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Thumb/soldierthumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Humans/soldier.png");
            var flesh = ModAPI.LoadTexture("Humans/flesh.png");
            var bone = ModAPI.LoadTexture("Humans/bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "PMC Altyn Infantry", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "A infantry that used the Altyn helmet.", //new item description
        CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Thumb/altynsoldierthumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Humans/altyn soldier.png");
            var flesh = ModAPI.LoadTexture("Humans/flesh.png");
            var bone = ModAPI.LoadTexture("Humans/bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "PMC Soldier", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "A highly trained soldier for the Green Jewel Company.", //new item description
        CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Thumb/soldier2thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Humans/soldier 2.png");
            var flesh = ModAPI.LoadTexture("Humans/flesh.png");
            var bone = ModAPI.LoadTexture("Humans/bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "PMC Recon Infantry", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "A soldier that is set to recon stuff.", //new item description
        CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Thumb/reconsoldierthumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Humans/recon soldier.png");
            var flesh = ModAPI.LoadTexture("Humans/flesh.png");
            var bone = ModAPI.LoadTexture("Humans/bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "PMC Spec Ops Infantry", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "A special operations operator.", //new item description
        CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Thumb/specialsoldierthumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("Humans/special soldier.png");
            var flesh = ModAPI.LoadTexture("Humans/flesh.png");
            var bone = ModAPI.LoadTexture("Humans/bone.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = "PMC Recruit Helmet", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A basic helmet used by recruits and other units.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/recruit helmet.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/recruit helmet.png"); //get the SpriteRenderer and replace its sprite with a custom one

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        armor.gasInhaleProtection = true;

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.scaleOffset = new Vector3(.01f, .01f);
                        prop.offset = new Vector3(.0f, .026f);
                        prop.sprite = "Armor/recruit helmet.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[0];
                        
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = "PMC Altyn Helmet", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A helmet with a shield used by Altyn infantry.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/altyn helmet.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/altyn helmet.png"); //get the SpriteRenderer and replace its sprite with a custom one

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        armor.gasInhaleProtection = true;

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 6;
                        prop.scaleOffset = new Vector3(.01f, .01f);
                        prop.offset = new Vector3(.0f, .026f);
                        prop.sprite = "Armor/altyn helmet.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[0];
                        
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = "PMC Helmet", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A harder helmet,used by soldiers and other units.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/combat helmet.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/combat helmet.png"); //get the SpriteRenderer and replace its sprite with a custom one

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        armor.gasInhaleProtection = true;

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 5;
                        prop.scaleOffset = new Vector3(.01f, .01f);
                        prop.offset = new Vector3(.0f, .026f);
                        prop.sprite = "Armor/combat helmet.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[0];
                        
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = "PMC Recon Helmet", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A modified version of the recruit helmet used by recon infantry.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/recon helmet.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/recon helmet.png"); //get the SpriteRenderer and replace its sprite with a custom one

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        armor.gasInhaleProtection = true;

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 5;
                        prop.scaleOffset = new Vector3(.01f, .01f);
                        prop.offset = new Vector3(.0f, .026f);
                        prop.sprite = "Armor/recon helmet.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[0];
                        
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = "PMC Spec Ops Helmet", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "A modified version of the altyn helmet used by spec ops.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Armor/special helmet.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/special helmet.png"); //get the SpriteRenderer and replace its sprite with a custom one

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        armor.gasInhaleProtection = true;

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 5;
                        prop.scaleOffset = new Vector3(.01f, .01f);
                        prop.offset = new Vector3(.0f, .026f);
                        prop.sprite = "Armor/special helmet.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[0];
                        
                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Soviet Submachine Gun"), //item to derive from
        NameOverride = "PPSH-2", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "the PPSH,a soviet machine gun,but now modified with a grip and other stuff.", //new item description
        CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Thumb/ppshthumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/ppsh.png");
                                        Instance.FixColliders();                              
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Shotgun"), //item to derive from
        NameOverride = "PPSH-3 (Shotgun)", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "a modification of the ppsh-2 what is a modification of the ppsh,its modified to be a shotgun,some called is PPShotgun.", //new item description
        CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Thumb/shotgunthumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/shotgun.png");
                                        Instance.FixColliders();                              
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), //item to derive from
        NameOverride = "PPMP5", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "A mp5 modified with modifcations from PPSH-2.", //new item description
        CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Thumb/smgthumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/smg.png");
                                        Instance.FixColliders();                              
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Assault Rifle"), //item to derive from
        NameOverride = "Jewel Rifle", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "A rifle made by the Green Jewel Company.", //new item description
        CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Thumb/arthumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/ar.png");
                                        Instance.FixColliders();                              
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("9mm Pistol"), //item to derive from
        NameOverride = "Glock", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Basicly a glock but with Green Jewel Camo.", //new item description
        CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Thumb/pistolthumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/pistol.png");
                                        Instance.FixColliders();                              
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Light Machine Gun"), //item to derive from
        NameOverride = "LMG", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "A machine gun,even tho its called light its still heavy.", //new item description
        CategoryOverride = ModAPI.FindCategory("Green Jewel"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Thumb/lmgthumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/lmg.png");
                                        Instance.FixColliders();                              
        }
    }
);

            
        }
    }
}